<?php


namespace TDevAgency\Cms\Commands;


use Exception;
use Illuminate\Console\Command;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Log;


class PublicAssets extends Command
{
    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Set symlink to assets';
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'cms:assets';

    /**
     * Execute the console command.
     *
     * @return mixed
     * @throws \Illuminate\Contracts\Container\BindingResolutionException
     */
    public function handle()
    {
        if (!file_exists(public_path('ckeditor'))) {
            if ($this->laravel->make('files')->exists(
                TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'ckeditor'
            )) {
                try {
                    $this->laravel->make('files')->link(
                        TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'ckeditor',
                        public_path('ckeditor')
                    );
                } catch (Exception $exception) {
                    Log::error($exception);
                }
            }
        }
        if (file_exists(public_path('cms'))) {
            File::cleanDirectory(public_path('cms'));
            $this->laravel->make('files')->deleteDirectory(public_path('cms'));
        }

        $this->laravel->make('files')->makeDirectory(public_path('cms'));

        if ($this->laravel->make('files')->exists(TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'js')) {
            try {
                $this->laravel->make('files')->link(
                    TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'js',
                    public_path('cms/js')
                );
            } catch (Exception $exception) {
                Log::error($exception);
            }
        }
        if ($this->laravel->make('files')->exists(TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'css')) {
            try {
                $this->laravel->make('files')->link(
                    TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'css',
                    public_path('cms/css')
                );
            } catch (Exception $exception) {
                Log::error($exception);
            }
        }
        if ($this->laravel->make('files')->exists(
            TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'cms' . DIRECTORY_SEPARATOR . 'fonts'
        )) {
            try {
                $this->laravel->make('files')->link(
                    TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'cms' . DIRECTORY_SEPARATOR . 'fonts',
                    public_path('cms/fonts')
                );
            } catch (Exception $exception) {
                Log::error($exception);
            }
        }
        if ($this->laravel->make('files')->exists(
            TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'cms' . DIRECTORY_SEPARATOR . 'images'
        )) {
            try {
                $this->laravel->make('files')->link(
                    TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'cms' . DIRECTORY_SEPARATOR . 'images',
                    public_path('cms/images')
                );
            } catch (Exception $exception) {
                Log::error($exception);
            }
        }


        $this->info('The [public/cms] directory has been linked.');
        return 0;
    }
}
