<?php

namespace TDevAgency\Cms\Notifications;

use Illuminate\Auth\Notifications\ResetPassword;
use Illuminate\Bus\Queueable;
use Illuminate\Notifications\Messages\MailMessage;
use Illuminate\Support\Facades\Config;
use Illuminate\Support\Facades\Lang;

class ResetPasswordNotification extends ResetPassword
{
    /**
     * Get the mail representation of the notification.
     *
     * @param mixed $notifiable
     * @return \Illuminate\Notifications\Messages\MailMessage
     */
    public function toMail($notifiable)
    {
        if (static::$toMailCallback) {
            return call_user_func(static::$toMailCallback, $notifiable, $this->token);
        }

        return (new MailMessage)
            ->subject(Lang::get('cms::mail.password_reset.subject', [], $notifiable->lang ?? Config::get('app.locale')))
            ->line(Lang::get('cms::mail.password_reset.line_1', [], $notifiable->lang ?? Config::get('app.locale')))
            ->action(Lang::get('cms::mail.password_reset.action', [], $notifiable->lang ?? Config::get('app.locale')), url(route('cms.password.reset', ['token' => $this->token, 'email' => $notifiable->getEmailForPasswordReset()], false)))
            ->line(Lang::get('cms::mail.password_reset.line_2', ['count' => config('auth.passwords.' . config('auth.defaults.passwords') . '.expire')], $notifiable->lang ?? Config::get('app.locale')))
            ->line(Lang::get('cms::mail.password_reset.line_3', [], $notifiable->lang ?? Config::get('app.locale')));

    }
}
